﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataGridUnboundCombo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DgCart2.DataContext = VmCartLineItems;
        }

        private void DgCart2_OnRecordsDeleted(object sender, Infragistics.Windows.DataPresenter.Events.RecordsDeletedEventArgs e)
        {

        }

        private void DgCart2_OnKeyUpDeleteItem(object sender, KeyEventArgs e)
        {

        }

        private void UpdateTotal(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {

        }

        ObservableCollection<LineItemsViewModel> VmCartLineItems = new ObservableCollection<LineItemsViewModel> {
            
                    new LineItemsViewModel {
                        Name = "asd",
                        AllowableShipMethods={                     
                                new ShippingMethods {ShippingName="name11", ShippingCode="code11"},
                                new ShippingMethods {ShippingName="naem12",ShippingCode="code12"}
                            }
                    },
                    new LineItemsViewModel {
                        Name = "asd2",
                        AllowableShipMethods={                             
                                 new ShippingMethods {ShippingName="name21", ShippingCode="code21"},
                                new ShippingMethods {ShippingName="name22",ShippingCode="code22"}
                            }
                    }
                
            
        };

        private void DgCart2_Loaded_1(object sender, RoutedEventArgs e)
        {

        }
    }   

    public class LineItemsViewModel : ViewModelProretyChanged
    {
        public string Name { get; set; }
        ObservableCollection<ShippingMethods> allowableShipMethods = new ObservableCollection<ShippingMethods>();
        public ObservableCollection<ShippingMethods> AllowableShipMethods
        {
            get
            {
                return this.allowableShipMethods;
            }

            set
            {
                if (this.allowableShipMethods != value)
                {
                    this.allowableShipMethods = value;

                    this.RaisePropertyChanged("AllowableShipMethods");
                }
            }
        }

        
    }

    public class ShippingMethods
    {
        public string ShippingName { get; set; }
        public string ShippingCode { get; set; }
        
    }

    public class ViewModelProretyChanged : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void RaisePropertyChanged(string propertyName)
        {
            RaisePropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
        protected virtual void RaisePropertyChanged(PropertyChangedEventArgs args)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, args);
        }  
    }
    

}
